;
; 80C386E3D Register definitions
;
; Define Macro for accessing the E3D registers.  Using these macros
; allows a user to move between high and low I/O space easily.
_SetE3DRegWord MACRO reg,val
   mov  dx,reg
   mov  ax,val
   out  dx,ax
ENDM
_SetE3DRegByte MACRO reg,val
   mov  dx,reg
   mov  al,val
	out  dx,al
ENDM

;  REMAP ADDRESSING REGISTERS
	  REMAPCFGH	EQU  0023H
	  REMAPCFGL	EQU  0022H

;  INTERRUPT CONTROL REGISTERS -- SLOT 15 ADDRESSES
     ICW1M      EQU 0F020H
     ICW1S      EQU 0F0A0H
     ICW2M      EQU 0F021H
     ICW2S      EQU 0F0A1H
	  ICW3M      EQU 0F021H
     ICW3S      EQU 0F0A1H
     ICW4M      EQU 0F021H
     ICW4S      EQU 0F0A1H
     OCW1M      EQU 0F021H
     OCW1S      EQU 0F0A1H
     OCW2M      EQU 0F020H
     OCW2S      EQU 0F0A0H
     OCW3M      EQU 0F020H
     OCW3S      EQU 0F0A0H
; INTERRUPT CONTROL REGISTERS -- SLOT 0 ADDRESSES
	  ICW1MDOS   EQU 0020H
     ICW1SDOS   EQU 00A0H
     ICW2MDOS   EQU 0021H
     ICW2SDOS   EQU 00A1H
     ICW3MDOS   EQU 0021H
     ICW3SDOS   EQU 00A1H
     ICW4MDOS   EQU 0021H
     ICW4SDOS   EQU 00A1H
     OCW1MDOS   EQU 0021H
     OCW1SDOS   EQU 00A1H
     OCW2MDOS   EQU 0020H
     OCW2SDOS   EQU 00A0H
     OCW3MDOS   EQU 0020H
     OCW3SDOS   EQU 00A0H


; CONFIGURATION REGISTERS
     DMACFG     EQU 0F830H
     INTCFG     EQU 0F832H
     TMRCFG     EQU 0F834H
     SIOCFG     EQU 0F836H
     P1CFG      EQU 0F820H
     P2CFG      EQU 0F822H
     P3CFG      EQU 0F824H
	  PINCFG     EQU 0F826H

; WATCHDOG TIMER REGISTERS
     WDTRLDH    EQU 0F4C0H
     WDTRLDL    EQU 0F4C2H
     WDTCNTH    EQU 0F4C4H
     WDTCNTL    EQU 0F4C6H
     WDTCLR     EQU 0F4C8H
     WDTSTATUS  EQU 0F4CAH

; TIMER CONTROL REGISTERS -- SLOT 15 ADDRESSES
     TMR0       EQU 0F040H
     TMR1       EQU 0F041H
     TMR2       EQU 0F042H
     TMRCON     EQU 0F043H
; TIMER CONTROL REGISTERS -- SLOT 0 ADDRESSES
     TMR0DOS    EQU 0040H
     TMR1DOS    EQU 0041H
     TMR2DOS    EQU 0042H
     TMRCONDOS  EQU 0043H

; INPUT/OUTPUT PORT UNIT REGISTERS
     P1PIN      EQU 0F860H
     P1LTC      EQU 0F862H
     P1DIR      EQU 0F864H
     P2PIN      EQU 0F868H
     P2LTC      EQU 0F86AH
     P2DIR      EQU 0F86CH
     P3PIN      EQU 0F870H
     P3LTC      EQU 0F872H
     P3DIR      EQU 0F874H

; ASYNCHRONOUS SERIAL CHANNEL 0 -- SLOT 15 ADDERSSES
     RBR0       EQU 0F4F8H
     THR0       EQU 0F4F8H
     DLL0       EQU 0F4F8H
     IER0       EQU 0F4F9H
     DLH0       EQU 0F4F9H
     IIR0       EQU 0F4FAH
     LCR0       EQU 0F4FBH
     MCR0       EQU 0F4FCH
     LSR0       EQU 0F4FDH
     MSR0       EQU 0F4FEH
     SCR0       EQU 0F4FFH
; ASYNCHRONOUS SERIAL CHANNEL 0 -- SLOT 0 ADDERSSES
     RBR0DOS    EQU 03F8H
     THR0DOS    EQU 03F8H
     DLL0DOS    EQU 03F8H
     IER0DOS    EQU 03F9H
     DLH0DOS    EQU 03F9H
     IIR0DOS    EQU 03FAH
     LCR0DOS    EQU 03FBH
     MCR0DOS    EQU 03FCH
     LSR0DOS    EQU 03FDH
     MSR0DOS    EQU 03FEH
     SCR0DOS    EQU 03FFH

; ASYNCHRONOUS SERIAL CHANNEL 1 -- SLOT 15 ADDRESSES
     RBR1       EQU 0F8F8H
     THR1       EQU 0F8F8H
     DLL1       EQU 0F8F8H
     IER1       EQU 0F8F9H
     DLH1       EQU 0F8F9H
     IIR1       EQU 0F8FAH
     LCR1       EQU 0F8FBH
     MCR1       EQU 0F8FCH
     LSR1       EQU 0F8FDH
     MSR1       EQU 0F8FEH
     SCR1       EQU 0F8FFH
; ASYNCHRONOUS SERIAL CHANNEL 1 -- SLOT 0 ADDRESSES
     RBR1DOS    EQU 02F8H
     THR1DOS    EQU 02F8H
     DLL1DOS    EQU 02F8H
     IER1DOS    EQU 02F9H
     DLH1DOS    EQU 02F9H
     IIR1DOS    EQU 02FAH
     LCR1DOS    EQU 02FBH
     MCR1DOS    EQU 02FCH
     LSR1DOS    EQU 02FDH
     MSR1DOS    EQU 02FEH
     SCR1DOS    EQU 02FFH

; SYNCHRONOUS SERIAL CHANNEL
     SSIOTBUF   EQU 0F480H
     SSIORBUF   EQU 0F482H
     SSIOBAUD   EQU 0F484H
     SSIOCON1   EQU 0F486H
     SSIOCON2   EQU 0F488H
     SSIOCTR    EQU 0F48AH

; CHIP SELECT UNIT REGISTERS
	  CS0ADL     EQU 0F400H
	  CS0ADH     EQU 0F402H
	  CS0MSKL    EQU 0F404H
	  CS0MSKH    EQU 0F406H
	  CS1ADL     EQU 0F408H
	  CS1ADH     EQU 0F40AH
	  CS1MSKL    EQU 0F40CH
	  CS1MSKH    EQU 0F40EH
	  CS2ADL     EQU 0F410H
	  CS2ADH     EQU 0F412H
	  CS2MSKL    EQU 0F414H
	  CS2MSKH    EQU 0F416H
	  CS3ADL     EQU 0F418H
	  CS3ADH     EQU 0F41AH
	  CS3MSKL    EQU 0F41CH
	  CS3MSKH    EQU 0F41EH
	  CS4ADL     EQU 0F420H
	  CS4ADH     EQU 0F422H
	  CS4MSKL    EQU 0F424H
	  CS4MSKH    EQU 0F426H
	  CS5ADL     EQU 0F428H
	  CS5ADH     EQU 0F42AH
	  CS5MSKL    EQU 0F42CH
	  CS5MSKH    EQU 0F42EH
	  CS6ADL     EQU 0F430H
	  CS6ADH     EQU 0F432H
     CS6MSKL    EQU 0F434H
     CS6MSKH    EQU 0F436H
	  UCSADL     EQU 0F438H
	  UCSADH     EQU 0F43AH
     UCSMSKL    EQU 0F43CH
     UCSMSKH    EQU 0F43EH

;  REFRESH CONTROL UNIT REGISTERS
     RFSBAD     EQU 0F4A0H
     RFSCIR     EQU 0F4A2H
     RFSCON     EQU 0F4A4H
     RFSADD     EQU 0F4A6H

;  POWER MANAGEMENT CONTROL REGISTERS
     PWRCON     EQU 0F800H
     CLKPRS     EQU 0F804H

;  DMA UNIT REGISTERS -- SLOT 15 ADDRESSES
     DMA0TAR    EQU 0F000H
     DMA0BYC    EQU 0F001H
     DMA1TAR    EQU 0F002H
     DMA1BYC    EQU 0F003H
     DMACMD1    EQU 0F008H
     DMASTS     EQU 0F008H
     DMASRR     EQU 0F009H
     DMAMSK     EQU 0F00AH
     DMAMOD1    EQU 0F00BH
     DMACLRBP   EQU 0F00CH
     DMACLR     EQU 0F00DH
     DMACLRMSK  EQU 0F00EH
     DMAGRPMSK  EQU 0F00FH
	  DMA0REQL   EQU 0F010H
     DMA0REQH   EQU 0F011H
     DMA1REQL   EQU 0F012H
     DMA1REQH   EQU 0F013H
     DMABSR     EQU 0F018H
     DMACHR     EQU 0F019H
     DMAIS      EQU 0F019H
     DMACMD2    EQU 0F01AH
     DMAMOD2    EQU 0F01BH
     DMAIEN     EQU 0F01CH
     DMAOVFE    EQU 0F01DH
	  DMACLRTC   EQU 0F01EH
	  DMA1TARPL  EQU 0F083H
	  DMA1TARPH  EQU 0F085H
     DMA0TARPH  EQU 0F086H
	  DMA0TARPL  EQU 0F087H
	  DMA0BYCH   EQU 0F098H
     DMA1BYCH   EQU 0F099H

;  DMA UNIT REGISTERS -- SLOT 0 ADDRESSES
	  DMA0TARDOS   EQU 0000H
     DMA0BYCDOS   EQU 0001H
     DMA1TARDOS   EQU 0002H
     DMA1BYCDOS   EQU 0003H
     DMACMD1DOS   EQU 0008H
     DMASTSDOS    EQU 0008H
     DMASRRDOS    EQU 0009H
     DMAMSKDOS    EQU 000AH
     DMAMOD1DOS   EQU 000BH
     DMACLRBPDOS  EQU 000CH
     DMACLRDOS    EQU 000DH
     DMACLRMSKDOS EQU 000EH
     DMAGRPMSKDOS EQU 000FH
	  DMA1TARPLDOS EQU 0083H
	  DMA0TARPLDOS EQU 0087H

; A20GATE AND FAST CPU RESET -- SLOT 15 ADDRESS
	  PORT92     EQU 0F092H
; A20GATE AND FAST CPU RESET -- SLOT 0 ADDRESS
	  PORT92DOS  EQU 0092H

