       TITLE   Initialize 386EX

;4.     Build Environment.
;       MASM 5.10, no special switches.
;       MASM 6.00, /Ml /T

	include e3d.inc

INITCODE        SEGMENT

	ASSUME  CS:CGROUP, DS:NOTHING, ES:NOTHING, SS:NOTHING
	PUBLIC  POST

INIT_EX    PROC    FAR


	in      al,92h          ;Clear Port 92 Reset
	and     al,0feh
	or      al,02h
	out     92H,al


	MOV     AX, 0080H       ; open expanded I/O space
	XCHG    AL, AH
	OUT     REMAPCFGH, AL
	XCHG    AL, AH
	OUT     REMAPCFGL, AL
	OUT     REMAPCFGL, AX

;Initialize the Watch Dog Timer for:
;  Watch Dog Timer Status = Disabled

  _SetE3DRegByte WDTSTATUS, 01H    ;Disable the WDT.

;Initialize the Refresh Control Unit for:
;  Refresh address of 0000H.
;  Refresh gate between rows is 15.6uSec
;  Using a CLK2 frequency of 50 MHz (25Mhz CPU operation)
;  The refresh control unit is Enabled.
;  The refresh pin is not used.

  _SetE3DRegWord RFSCIR, 390      ;Program refresh interval.
  _SetE3DRegWord RFSBAD, 00H      ;Program base address.
  _SetE3DRegWord RFSADD, 00H      ;Program address register.
  _SetE3DRegWord RFSCON, 8000H    ;Program the enable bit.

;Initialize I/O Port 1 for:
;  PIN 0 = 1, DCD0
;  PIN 1 = 1, RTS0
;  PIN 2 = 1, DTR0
;  PIN 3 = 1, DSR0
;  PIN 4 = 1, RI0
;  PIN 5 = 0, OutPort (FLASH Vpp Enable, 0=Enable  1=Disable)
;  PIN 6 = 0, OutPort
;  PIN 7 = 0, OutPort

	_SetE3DRegByte P1LTC, 0FFH
	_SetE3DRegByte P1DIR, 00H
	_SetE3DRegByte P1CFG, 01FH


;Initialize I/O Port 2 for:
;  PIN 0 = 1, OutPort
;  PIN 1 = 1, OutPort
;  PIN 2 = 1, CS2# (SMRAM)
;  PIN 3 = 0, OutPort
;  PIN 4 = 1, CS4# (DRAM)
;  PIN 5 = 1, RXD0
;  PIN 6 = 1, TXD0
;  PIN 7 = 1, CTS0

	_SetE3DRegByte P2LTC, 0FFH
	_SetE3DRegByte P2DIR, 00H
	_SetE3DRegByte P2CFG, 0F4H

;Initialize I/O Port 3 for:
;  PIN 0 = 0, InPort (Downloader, 0=Bypass  1=Execute)
;  PIN 1 = 0, OutPort
;  PIN 2 = 1, OutPort
;  PIN 3 = 1, INT1
;  PIN 4 = 1, INT2
;  PIN 5 = 1, INT3
;  PIN 6 = 0, InPort (Debugger Break)
;  PIN 7 = 1, COMCLK

	_SetE3DRegByte P3LTC, 0FFH
	_SetE3DRegByte P3DIR, 41H
	_SetE3DRegByte P3CFG, 0B8H

; Initialize Peripheral Pin Configurations
;  PIN 0 = 0, SSIOTX
;  PIN 1 = 0, SRXCLK
;  PIN 2 = 1, TXD1
;  PIN 3 = 0, EOP#/TC
;  PIN 4 = 0, DACK0#
;  PIN 5 = 1, Timer2
;  PIN 6 = 0, GCS6#
;  PIN 7 = 0, Don't Care

	_SetE3DRegByte PINCFG, 024H

;Initialize Chip Select Unit for:
;  UCS:   Start address is 03F80000H.
;         Region size is 512 KBytes.
;         2 wait states.
;         Chip select is Enabled.
;         16 bit data bus size in memory space.
;         External bus ready is Disabled.
;         Accessable in SMM

	_SetE3DRegWord UCSADL, 0302H    ;Set the upper chip select
	_SetE3DRegWord UCSADH, 03F8H
	_SetE3DRegWord UCSMSKL, 0FC01H
	_SetE3DRegWord UCSMSKH, 0007H

;  CS0:   Not Used

;  CS1:   Not Used

;  CS2:   Start address is 38000H.
;         Region size is 32 Kbytes.
;         2 wait states.
;         Chip select is Enabled.
;         8 bit data bus size in memory space.
;         External bus ready is Disabled.
;         Not accessable outside SMM.

	_SetE3DRegWord CS2ADL, 8502H    ;Set chip select 2
	_SetE3DRegWord CS2ADH, 03H
	_SetE3DRegWord CS2MSKL, 7801H
	_SetE3DRegWord CS2MSKH, 0H

;  CS3:   Start address is 0A0000H.
;         Region size is 128 Kbytes.
;         0 wait states.
;         Chip select is Enabled.
;         16 bit data bus size in memory space.
;         External bus ready is Enabled.
;         Accessable in SMM.

	_SetE3DRegWord CS3ADL, 0380H
	_SetE3DRegWord CS3ADH, 0AH
	_SetE3DRegWord CS3MSKL, 0FC01H
	_SetE3DRegWord CS3MSKH, 1H

;  CS4:  Start address is 0H.
;         Region size is 16 MBytes.
;         2 wait states.
;         Chip select is Enabled.
;         16 bit data bus size in memory space.
;         External bus ready is Disabled.
;         Accessable in SMM.

	_SetE3DRegWord CS4ADL, 0302H   ;Set chip select 4
	_SetE3DRegWord CS4ADH, 00H
	_SetE3DRegWord CS4MSKL, 0FC01H
	_SetE3DRegWord CS4MSKH, 0FFH

;  CS5:   Start address is 0C0000H.
;         Region size is 128 Kbytes.
;         0 wait states.
;         Chip select is Enabled.
;         16 bit data bus size in memory space.
;         External bus ready is Enabled.
;         Accessable in SMM.

	_SetE3DRegWord CS5ADL, 0380H
	_SetE3DRegWord CS5ADH, 0CH
	_SetE3DRegWord CS5MSKL, 0FC01H
	_SetE3DRegWord CS5MSKH, 1H

;  CS6:   Start address is 0E0000H.
;         Region size is 128 Kbytes.
;         2 wait states.
;         Chip select is Enabled.
;         16 bit data bus size in memory space.
;         External bus ready is Disabled.
;         Accessable in SMM

	_SetE3DRegWord CS6ADL, 0302H   ;Set chip select 6
	_SetE3DRegWord CS6ADH, 0EH
	_SetE3DRegWord CS6MSKL, 0FC01H
	_SetE3DRegWord CS6MSKH, 1H


;Initialize the Clock and Power Management Unit for:
;  Clock frequency of 50 MHz
;  Prescaled clock output of  1.19318 MHz
;  Normal Halt Instructions

	 _SetE3DRegByte PWRCON, 00H
	 _SetE3DRegWord CLKPRS, 15H

;Initialize the Asynchronous Serial Ports
;
; Bit 7 = 1, Internal SIO1 modem signals
; Bit 6 = 0, External SIO0 modem signals
; Bit 2 = 0, PSCLK for SSIO clock
; Bit 1 = 0, COMCLK for SIO1 clock
; Bit 0 = 0, COMCLK for SIO0 clock

	_SetE3DRegByte SIOCFG, 080H    ;Set clocking and modem control sources.

;Initialize Timer 0 for:
;
; Bit 7 = 0, Timer clocks enabled
; Bit 5 = 0, Vcc to Gate2
; Bit 4 = 0, PSCLK to CLK2
; Bit 3 = 0, Vcc to Gate1
; Bit 2 = 0, PSCLK to CLK1
; Bit 1 = 0, Vcc to Gate0
; Bit 0 = 0, PSCLK to CLK0

	_SetE3DRegByte TMRCFG, 00H    ;Set input sources.

;Initialize the DMACFG register for:
;
; Bit 7 = 1, Disable DACK1#
; Bits 6:4 = 100, TMROUT2 connected to DRQ1
; Bit 3 = 0, Enable DACK0#
; Bits 2:0 = 000, Pin is conneced to DRQ0

	_SetE3DRegByte  DMACFG, 0C0H

;Initialize the INTCFG register for:
;
; Bit 7 = 0, Disable CAS lines
; Bit 3 = 1, Pin is connected to IRQ7
; Bit 2 = 1, Pin is connected to IRQ6
; Bit 1 = 1, Pin is connected to IRQ5
; Bit 0 = 1, Pin is connected to IRQ4

	_SetE3DRegByte  INTCFG, 0FH

;       disable the expanded I/O space

	MOV     AL, 00H
	OUT     REMAPCFGH,AL

; far jump to start of user routine
	db      0eah
	dw      0xxxxh             	; Place IP location here
	dw      0xxxxh                  ; Place CS location here



INIT_EX    ENDP


;***   PowerGood - Power-On Reset Boot Code.
;
;   FUNCTIONAL DESCRIPTION.
;       This routine is the far JMP instruction located at address ffff:0000
;       in ROM.

	ASSUME  CS:CGROUP, DS:NOTHING, ES:NOTHING, SS:NOTHING
	ORG     0FFFF:0
	PUBLIC  Power_Good

Power_Good PROC FAR

	JMP     INIT_EX

Power_Good ENDP

INITCODE ENDS
	END
